# Clustering.jl

This package provides a set of algorithms for data clustering.

[![0.5](http://pkg.julialang.org/badges/Clustering_0.5.svg)](http://pkg.julialang.org/?pkg=Clustering)
[![0.6](http://pkg.julialang.org/badges/Clustering_0.6.svg)](http://pkg.julialang.org/?pkg=Clustering)
[![Travis](https://travis-ci.org/JuliaStats/Clustering.jl.svg?branch=master)](https://travis-ci.org/JuliaStats/Clustering.jl)
[![Coveralls](https://coveralls.io/repos/github/JuliaStats/Clustering.jl/badge.svg?branch=master)](https://coveralls.io/github/JuliaStats/Clustering.jl?branch=master)

## Installation

```julia
Pkg.add("Clustering")
```

## Functionalities

### Clustering Algorithms

- K-means
- K-medoids
- Affinity Propagation
- Density-based spatial clustering of applications with noise (DBSCAN)
- Markov Clustering Algorithm (MCL)
- Fuzzy C-Means Clustering
- Hierarchical Clustering
  - Single Linkage
  - Average Linkage
  - Complete Linkage

### Clustering Validation

- Silhouettes
- Variation of Information
- Rand index

## Resources

**Documentation:** http://clusteringjl.readthedocs.org/en/latest/


